import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopGoods, ShopGoodsParam } from './model';


/**
 * 分页查询商品
 */
export async function pageShopGoods(params: ShopGoodsParam) {
  const res = await request.get<ApiResult<PageResult<ShopGoods>>>(
    '/shop/shop-goods/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询商品列表
 */
export async function listShopGoods(params?: ShopGoodsParam) {
  const res = await request.get<ApiResult<ShopGoods[]>>(
    '/shop/shop-goods',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加商品
 */
export async function addShopGoods(data: ShopGoods) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-goods',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改商品
 */
export async function updateShopGoods(data: ShopGoods) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-goods',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除商品
 */
export async function removeShopGoods(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-goods/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除商品
 */
export async function removeBatchShopGoods(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-goods/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询商品
 */
export async function getShopGoods(id: number) {
  const res = await request.get<ApiResult<ShopGoods>>(
    '/shop/shop-goods/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

export async function getCount(params: ShopGoodsParam) {
  const res = await request.get<ApiResult<unknown>>('/shop/shop-goods/data', {
    params
  });
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
